
#ifndef __SCRIPT_H__
#define __SCRIPT_H__

#ifdef __cplusplus
extern "C" {
#endif

//---------------------------------------------------------------------------
#define SCRIPT_MAX_VALUE_CNT		256			//ϐe[ǔ
#define SCRIPT_FILE_LEN				30

//---------------------------------------------------------------------------
//R}hR[h
enum {
	CMD_VALUE_SET,		// 0x00
	CMD_CALC_VALUE,
	CMD_TEXT,
	CMD_CLEAR_TEXT,
	CMD_GOTO,
	CMD_IF_TRUE,		// 0x05
	CMD_IF_FALSE,
	CMD_IF_BIGGER,
	CMD_IF_SMALLER,
	CMD_IF_BIGGER_EQU,
	CMD_IF_SMALLER_EQU,	// 0x0a
	CMD_MENU_INIT,
	CMD_MENU_ITEM,
	CMD_MENU,
	CMD_EXEC,
	CMD_LOAD,
	CMD_UPDATE,			// 0x10
	CMD_CLEAR,
	CMD_MODE,
	CMD_SYS_EXIT,
	CMD_SYS_CLEAR,
	CMD_END,			// 0x15
};

//CG|WV
enum {
	POSITION_BACK,       // wi
	POSITION_BACKONLY,   // wî
	POSITION_CENTER,     // 
	POSITION_LEFT,       // 
	POSITION_RIGHT,      // E
	POSITION_OVERLAP,    // d
};

//[htO
enum {
	MODE_SYSTEM,
	MODE_SCENARIO,
};

//SCREENɓnbZ[WtO
enum {
	SCRIPT_FLAG_MESSAGE    = 0x01,
	SCRIPT_FLAG_UPDATE,
	SCRIPT_FLAG_CLEAR_TEXT,
	SCRIPT_FLAG_CLEAR,
	SCRIPT_FLAG_LOAD,
	SCRIPT_FLAG_WAIT,
	SCRIPT_FLAG_MENU_INIT,
	SCRIPT_FLAG_MENU_ITEM,
	SCRIPT_FLAG_MENU,
	SCRIPT_FLAG_END,
};
//---------------------------------------------------------------------------
typedef struct {
	u8  sig[8];								//VOl` "[SCRIPT]"
	u32 len;								//XNvg̒
} ST_SCRIPT_HEADER;


typedef struct {
	u8  scrName[SCRIPT_FILE_LEN];			//XNvg̃t@C
	u8* pos;								//XNvg̐擪ʒu
	u32 len;								//XNvg̒
	u32 cnt;								//ǂݍ݈ʒu

	//ϐe[u
	s8  valueTbl[SCRIPT_MAX_VALUE_CNT];

	//SCREENɓntO
	u16 flagCmd;
	u16 flagSub;
	u8* str;
} ST_SCRIPT;


//R}ĥ݂̋ʍ\
typedef struct {
	u8  type;
	u8  size;
	u8  dummy[2];
} ST_SINGLE_CMD;


typedef ST_SINGLE_CMD ST_TEXT_CLEAR;
typedef ST_SINGLE_CMD ST_END;
typedef ST_SINGLE_CMD ST_MENU_INIT;
typedef ST_SINGLE_CMD ST_UPDATE;


//setR}h\
typedef struct {
	u8  type;
	u8  size;
	u16 valueAdr;
	s32 setValue;
} ST_VALUE_SET;


//calcR}h\
typedef struct {
	u8  type;
	u8  size;
	u16 valueAdr;
	s32 addValue;
} ST_VALUE_CALC;


//textR}h\
typedef struct {
	u8  type;
	u8  size;
	u16 msgLen;
} ST_TEXT;


//gotoR}h\
typedef struct {
	u8  type;
	u8  size;
	u8  dummy[2];
	u32 gotoLabel;
} ST_GOTO;


//ifR}h\
typedef struct {
	u8  type;
	u8  size;
	u8  flag;
	u8  dummy;
	s32 value1;
	s32 value2;
	u32 gotoLabel;
} ST_IF;


//menuR}h\
typedef struct {
	u8  type;
	u8  size;
	u16 valueAdr;
} ST_MENU;


//j[ڃR}h\
typedef struct {
	u8  type;
	u8  size;
	u8  number;
	u8  labelLen;
} ST_MENU_ITEM;


//execR}h\
typedef struct {
	u8  type;
	u8  size;
	u8  dummy;
	u8  pathLen;
} ST_EXEC;


//loadR}h\
typedef struct {
	u8  type;
	u8  size;
	u8  flag;
	u8  pathLen;
} ST_LOAD;


//clearR}h\
typedef struct {
	u8  type;
	u8  size;
	u8  pos;
	u8  dummy;
} ST_CLEAR;


//modeR}h\
typedef struct {
	u8  type;
	u8  size;
	u8  mode;
	u8  dummy;
} ST_MODE;



typedef union {
	struct {
		u8  type;
		u8  size;
	} common;

	ST_VALUE_SET  set;
	ST_VALUE_CALC calc;
	ST_TEXT       text;
	ST_TEXT_CLEAR clearText;
	ST_GOTO       cmdGoto;
	ST_IF         cmdIf;
	ST_MENU_INIT  menuInit;
	ST_MENU       menu;
	ST_MENU_ITEM  menuItem;
	ST_LOAD       load;
	ST_UPDATE     update;
	ST_CLEAR      clear;
	ST_EXEC       exec;
	ST_MODE       mode;
	ST_END        end;
} ST_CMD;


//---------------------------------------------------------------------------

EWRAM_CODE void    ScriptInit();
EWRAM_CODE void    ScriptExec();
EWRAM_CODE void    ScriptLoad(u8* pScr);


EWRAM_CODE void    ScriptCmdLoad(u8* str);
EWRAM_CODE void    ScriptCmdSetValue(u16 adr, s32 value);
EWRAM_CODE void    ScriptCmdCalcValue(u16 adr, s32 value);
EWRAM_CODE void    ScriptCmdGoto(u32 gotoCnt);
EWRAM_CODE s32     ScriptCmdGetValue(s32 adr, u8 flag);
EWRAM_CODE u8*     ScriptCmdGetString(u16 msgLen);
EWRAM_CODE void    ScriptCmdClear();


EWRAM_CODE bool    ScriptIsScr(u8* pFile);
EWRAM_CODE bool    ScriptIsEnd();


EWRAM_CODE ST_CMD* ScriptGetCmd();


//----


#ifdef __cplusplus
}
#endif
#endif

